From: "Benda XU" <heroxbd@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: sci-libs/rocFFT/files/, sci-libs/rocFFT/
Date: Sun, 27 Mar 2022 03:12:58 +0000 (UTC) [thread overview]
Message-ID: <1648350771.83c4bf0776b5e64867f547284ca794254dab36f7.heroxbd@gentoo> (raw)
commit: 83c4bf0776b5e64867f547284ca794254dab36f7
Author: YiyangWu <xgreenlandforwyy <AT> gmail <DOT> com>
AuthorDate: Wed Mar 23 14:22:16 2022 +0000
Commit: Benda XU <heroxbd <AT> gentoo <DOT> org>
CommitDate: Sun Mar 27 03:12:51 2022 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=83c4bf07
sci-libs/rocFFT: bump version to 5.0.2
Enable benchmark and perfscript USE flags.
Closes: https://github.com/gentoo/gentoo/pull/24726
Package-Manager: Portage-3.0.30, Repoman-3.0.3
Signed-off-by: Yiyang Wu <xgreenlandforwyy <AT> gmail.com>
Signed-off-by: Benda Xu <heroxbd <AT> gentoo.org>
sci-libs/rocFFT/Manifest | 1 +
| 12 ++
.../files/rocFFT-5.0.2-unbundle-sqlite.patch | 54 ++++++++
sci-libs/rocFFT/metadata.xml | 4 +
sci-libs/rocFFT/rocFFT-5.0.2.ebuild | 148 +++++++++++++++++++++
5 files changed, 219 insertions(+)
diff --git a/sci-libs/rocFFT/Manifest b/sci-libs/rocFFT/Manifest
index 8757f213cfe1..a6b401c669d5 100644
--- a/sci-libs/rocFFT/Manifest
+++ b/sci-libs/rocFFT/Manifest
@@ -1,2 +1,3 @@
DIST rocFFT-4.0.0.tar.gz 772176 BLAKE2B f08db9487449e707ba814a66d23992f68c140017a38f72ee45b3b224fc3e46abd40b976aef645f4432601265b38cff8939456981c686360eba135349b5d28fb5 SHA512 db9a6b49162dfb7924aa5f5dc8d42c92a5a741e03c3c0b4ece2cfb72de7506a345f3d28d31a3d7755cfe78078c448c9f952ca671e472335a4301de8702916176
DIST rocFFT-4.3.0.tar.gz 840748 BLAKE2B 236a5faa930751d35e501a9a32ecc8b4075448ef21a0ffb0bb7ec04f4ed1cb67b908aa153b5b424e0823d3e306cf375d7c01a77d687220ed79de6d374037e003 SHA512 765d41e4018a04a53e847c03de80eec830d3e8766187fb8cb493624afa2673175347c16e6eeeebd4ad7d88bb866e58f7e572708f22238723c710b98565a0cd3d
+DIST rocFFT-5.0.2.tar.gz 837508 BLAKE2B b74d0c6edd7b232f775bffefbca829d88d9d7cd9108c27a0698f45d7fe2760d40463bcda8c710e923874b3bbfb1e83e0fe8622db4dfa28afb29392b3e135e9a5 SHA512 d6810a92a10a27dbcac8a04e8fcd56c7fa198f208da626d8938d5ff28b6ab8b89a058c7a56b5666464165e8f6bd7c4c031a94315625a3613eb02a9b8eccd9eb9
--git a/sci-libs/rocFFT/files/rocFFT-5.0.2-add-math-header.patch b/sci-libs/rocFFT/files/rocFFT-5.0.2-add-math-header.patch
new file mode 100644
index 000000000000..1a35126f1d8c
--- /dev/null
+++ b/sci-libs/rocFFT/files/rocFFT-5.0.2-add-math-header.patch
@@ -0,0 +1,12 @@
+fix compilation issue: error: use of undeclared identifier 'ceil' 'floor'
+===================================================================
+--- rocFFT-rocm-5.0.2.orig/library/src/device/generator/stockham_gen_base.h
++++ rocFFT-rocm-5.0.2/library/src/device/generator/stockham_gen_base.h
+@@ -20,6 +20,7 @@
+
+ #pragma once
+ #include "stockham_gen.h"
++#include <math.h>
+
+ // Base class for stockham kernels. Subclasses are responsible for
+ // different tiling types.
diff --git a/sci-libs/rocFFT/files/rocFFT-5.0.2-unbundle-sqlite.patch b/sci-libs/rocFFT/files/rocFFT-5.0.2-unbundle-sqlite.patch
new file mode 100644
index 000000000000..4da2b2092906
--- /dev/null
+++ b/sci-libs/rocFFT/files/rocFFT-5.0.2-unbundle-sqlite.patch
@@ -0,0 +1,54 @@
+Disable rocFFT fetching SQLite3 and link to system libsqlite.so
+--- rocFFT-rocm-5.0.2/library/src/CMakeLists.txt
++++ rocFFT-rocm-5.0.2/library/src/CMakeLists.txt
+@@ -134,31 +134,7 @@ set( rocfft_source
+ rtcsubprocess.cpp
+ )
+
+-# SQLite 3.36.0 enabled the backup API by default, which we need
+-# for cache serialization. We also want to use a static SQLite,
+-# and distro static libraries aren't typically built
+-# position-independent.
+-include( FetchContent )
+-
+-# embed SQLite
+-FetchContent_Declare(sqlite_local
+- URL https://sqlite.org/2021/sqlite-amalgamation-3360000.zip
+- URL_HASH SHA256=999826fe4c871f18919fdb8ed7ec9dd8217180854dd1fe21eea96aed36186729
+-)
+-FetchContent_MakeAvailable(sqlite_local)
+-add_library( sqlite3 STATIC ${sqlite_local_SOURCE_DIR}/sqlite3.c )
+-set_target_properties( sqlite3 PROPERTIES
+- C_VISIBILITY_PRESET "hidden"
+- VISIBILITY_INLINES_HIDDEN ON
+- POSITION_INDEPENDENT_CODE ON
+- )
+-
+-# we don't need extensions, and omitting them from SQLite removes the
+-# need for dlopen/dlclose from within rocFFT
+-target_compile_options(
+- sqlite3
+- PRIVATE -DSQLITE_OMIT_LOAD_EXTENSION
+-)
++find_package( SQLite3 REQUIRED )
+
+ set_property(
+ SOURCE rtc.cpp
+@@ -170,7 +146,7 @@ prepend_path( ".." rocfft_headers_public
+ add_library( rocfft ${rocfft_source} ${relative_rocfft_headers_public} )
+ add_library( roc::rocfft ALIAS rocfft )
+
+-target_link_libraries( rocfft PRIVATE stockham_gen sqlite3 )
++target_link_libraries( rocfft PRIVATE stockham_gen ${SQLite3_LIBRARIES} )
+ if( NOT WIN32 )
+ target_link_libraries( rocfft PRIVATE -lstdc++fs )
+ endif()
+@@ -203,7 +179,7 @@ endif()
+ target_include_directories( rocfft
+ PRIVATE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/src/include>
+ $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/library/src/device>
+- ${sqlite_local_SOURCE_DIR}
++ ${SQLite3_LIBRARIES}
+ PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
+ $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
+ $<INSTALL_INTERFACE:include/rocFFT>
diff --git a/sci-libs/rocFFT/metadata.xml b/sci-libs/rocFFT/metadata.xml
index 3274277df8c4..825327b204eb 100644
--- a/sci-libs/rocFFT/metadata.xml
+++ b/sci-libs/rocFFT/metadata.xml
@@ -16,4 +16,8 @@
<upstream>
<remote-id type="github">ROCmSoftwarePlatform/rocFFT</remote-id>
</upstream>
+ <use>
+ <flag name="benchmark">Build and install [dyna-]rocfft-rider.</flag>
+ <flag name="perfscripts">Install rocfft-perf performance visualization suite.</flag>
+ </use>
</pkgmetadata>
diff --git a/sci-libs/rocFFT/rocFFT-5.0.2.ebuild b/sci-libs/rocFFT/rocFFT-5.0.2.ebuild
new file mode 100644
index 000000000000..8d0cb72d3ed8
--- /dev/null
+++ b/sci-libs/rocFFT/rocFFT-5.0.2.ebuild
@@ -0,0 +1,148 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{8..10} )
+
+inherit cmake check-reqs multiprocessing python-r1
+
+DESCRIPTION="Next generation FFT implementation for ROCm"
+HOMEPAGE="https://github.com/ROCmSoftwarePlatform/rocFFT"
+SRC_URI="https://github.com/ROCmSoftwarePlatform/rocFFT/archive/rocm-${PV}.tar.gz -> rocFFT-${PV}.tar.gz"
+
+LICENSE="MIT"
+KEYWORDS="~amd64"
+SLOT="0/$(ver_cut 1-2)"
+
+# RDEPEND: perfscripts? dev-python/plotly[${PYTHON_USEDEP}] # currently masked by arch/amd64/x32/package.mask
+RDEPEND="
+perfscripts? (
+ >=media-gfx/asymptote-2.61
+ dev-texlive/texlive-latex
+ dev-tex/latexmk
+ sys-apps/texinfo
+ dev-python/sympy[${PYTHON_USEDEP}]
+ dev-python/numpy[${PYTHON_USEDEP}]
+ dev-python/scipy[${PYTHON_USEDEP}]
+ dev-python/pandas[${PYTHON_USEDEP}] )
+${PYTHON_DEPS}"
+
+DEPEND="dev-util/hip:${SLOT}
+ ${PYTHON_DEPS}"
+
+BDEPEND="
+ test? ( dev-cpp/gtest dev-libs/boost
+ >=sci-libs/fftw-3
+ >=dev-util/cmake-3.22
+ dev-util/rocm-cmake:${SLOT}
+)"
+
+CHECKREQS_DISK_BUILD="7G"
+
+IUSE="benchmark perfscripts test"
+REQUIRED_USE="perfscripts? ( benchmark ) ${PYTHON_REQUIRED_USE}"
+
+RESTRICT="!test? ( test )"
+
+S="${WORKDIR}/rocFFT-rocm-${PV}"
+
+PATCHES=(
+ "${FILESDIR}/${PN}-4.2.0-add-functional-header.patch"
+ "${FILESDIR}/${PN}-5.0.2-unbundle-sqlite.patch"
+ "${FILESDIR}/${PN}-5.0.2-add-math-header.patch" )
+
+required_mem() {
+ if use test; then
+ echo "52G"
+ else
+ if [[ -n "${AMDGPU_TARGETS}" ]]; then
+ local NARCH=$(($(awk -F";" '{print NF-1}' <<< "${AMDGPU_TARGETS}" || die)+1)) # count how many archs user specified in ${AMDGPU_TARGETS}
+ else
+ local NARCH=7 # The default number of AMDGPU_TARGETS for rocFFT-4.3.0. May change in the future.
+ fi
+ echo "$(($(makeopts_jobs)*${NARCH}*25+2200))M" # A linear function estimating how much memory required
+ fi
+}
+
+pkg_pretend() {
+ return # leave the disk space check to pkg_setup phase
+}
+
+pkg_setup() {
+ export CHECKREQS_MEMORY=$(required_mem)
+ check-reqs_pkg_setup
+ python_setup
+}
+
+src_prepare() {
+ sed -e "s/PREFIX rocfft//" \
+ -e "/rocm_install_symlink_subdir/d" \
+ -e "/<INSTALL_INTERFACE/s,include,include/rocFFT," \
+ -i library/src/CMakeLists.txt || die
+
+ sed -e "/rocm_install_symlink_subdir/d" \
+ -e "$!N;s:PREFIX\n[ ]*rocfft:# PREFIX rocfft\n:;P;D" \
+ -i library/src/device/CMakeLists.txt || die
+
+ if use perfscripts; then
+ pushd scripts/perf || die
+ sed -e "/\/opt\/rocm/d" -e "/rocmversion/s,rocm_info.strip(),\"${PV}\"," -i perflib/specs.py || dir
+ sed -e "/^top/,+1d" -i rocfft-perf suites.py || die
+ sed -e "s,perflib,${PN}_perflib,g" -i rocfft-perf suites.py perflib/*.py || die
+ sed -e "/^top = /s,__file__).*$,\"${EPREFIX}/usr/share/${PN}-perflib\")," -i perflib/pdf.py perflib/generators.py || die
+ popd
+ fi
+
+ cmake_src_prepare
+}
+
+src_configure() {
+ # Grant access to the device
+ addwrite /dev/kfd
+ addpredict /dev/dri/
+
+ # Compiler to use
+ export CXX=hipcc
+
+ local mycmakeargs=(
+ -Wno-dev
+ -DCMAKE_INSTALL_INCLUDEDIR="include/rocFFT/"
+ -DCMAKE_SKIP_RPATH=ON
+ -DBUILD_CLIENTS_TESTS=$(usex test ON OFF)
+ -DBUILD_CLIENTS_SELFTEST=$(usex test ON OFF)
+ -DBUILD_CLIENTS_RIDER=$(usex benchmark ON OFF)
+ ${AMDGPU_TARGETS+-DAMDGPU_TARGETS="${AMDGPU_TARGETS}"}
+ )
+
+ cmake_src_configure
+}
+
+src_test() {
+ addwrite /dev/kfd
+ addpredict /dev/dri
+ cd "${BUILD_DIR}/clients/staging" || die
+ einfo "Running rocfft-test"
+ LD_LIBRARY_PATH=${BUILD_DIR}/library/src/:${BUILD_DIR}/library/src/device ./rocfft-test || die
+
+ einfo "Running rocfft-selftest"
+ LD_LIBRARY_PATH=${BUILD_DIR}/library/src/:${BUILD_DIR}/library/src/device ./rocfft-selftest || die
+}
+
+src_install() {
+ cmake_src_install
+
+ if use benchmark; then
+ cd "${BUILD_DIR}"/clients/staging || die
+ dobin *rider
+ fi
+
+ if use perfscripts; then
+ cd "${S}"/scripts/perf || die
+ python_foreach_impl python_doexe rocfft-perf
+ python_moduleinto ${PN}_perflib
+ python_foreach_impl python_domodule perflib/*.py
+ insinto /usr/share/${PN}-perflib
+ doins *.asy suites.py
+ fi
+}
next reply other threads:[~2022-03-27 3:13 UTC|newest]
Thread overview: 4+ messages / expand[flat|nested] mbox.gz Atom feed top
2022-03-27 3:12 Benda XU [this message]
-- strict thread matches above, loose matches on Subject: below --
2023-02-01 9:53 [gentoo-commits] repo/gentoo:master commit in: sci-libs/rocFFT/files/, sci-libs/rocFFT/ Andreas Sturmlechner
2025-01-26 14:00 Sam James
2025-02-13 8:38 Sam James
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1648350771.83c4bf0776b5e64867f547284ca794254dab36f7.heroxbd@gentoo \
--to=heroxbd@gentoo.org \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox